package sundrysale;

/**
 * ^Cg:
 * :
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author
 * @version 1.0
 */

import java.sql.*;
import java.text.*;

public class CustomerAccess {

  //  ǉSQL
  private final String  INS_CUSTOMER  = "INSERT INTO CUSTOMER (CUSTNO,FNAME,LNAME,ADDER1,ADDER2,ZIP,PHONE,FAX,E_MAIL,SETDATE) VALUES (?,?,?,?,?,?,?,?,?,?)";
  //  ̒ǉ
  private void  insCustomer(Connection conn,MemberBean mb) throws  Exception {
    try {
      PreparedStatement ps  = conn.prepareStatement(INS_CUSTOMER);
      ps.setLong(1,mb.getMemberCd());   //  ԍ
      ps.setString(2,mb.getFirstName());//  
      ps.setString(3,mb.getLastName());  //  
      ps.setString(4,mb.getAdder1());   //  AhXP
      ps.setString(5,mb.getAdder2());   //  AhXQ
      ps.setString(6,mb.getZip());      //  X֔ԍ
      ps.setString(7,mb.getPhone());    //  dbԍ
      ps.setString(8,mb.getFax());      //  FAXԍ
      ps.setString(9,mb.getEMail());    //  [AhX
      ps.setDate(10,new java.sql.Date(mb.getSDate().getTime())); //  o^

      ps.executeUpdate(); //  ̒ǉ
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
  }

  //  Vԍ擾SQL
  private final String  GET_MEMBERCD  = "SELECT * FROM GETCUSTNO";
  //  Vԍ̎擾
  private long getMemberCd(Connection conn) throws  Exception {
    long  w = 0;
    try {
      PreparedStatement ps  = conn.prepareStatement(GET_MEMBERCD);
      ResultSet rs  = ps.executeQuery();
      while (rs.next()) {
        w = rs.getLong(1);
      }
      rs.close();
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
    return  w;
  }

  //  OC[U[ApX[hBean̍쐬
  private CustLoginBean makeCustLoginBean(MemberBean mb) {
    CustLoginBean clb = new CustLoginBean();
    clb.setCustNo(mb.getMemberCd());

    DecimalFormat df  = new DecimalFormat("00000000");
    clb.setLUserName("US"+df.format(mb.getMemberCd()));
    clb.setLPassword("PS"+df.format(mb.getMemberCd()));

    return  clb;
  }

  //  OC[U[ApX[ho^SQL
  private final String ISN_CUSTLOGIN  = "INSERT INTO CUSTLOGIN (CUSTNO,LUSERNAME,LPASSWORD) VALUES (?,?,?)";
  //  OC@[U[ApX[ho^
  private void  insCustLogin(Connection conn,CustLoginBean clb) throws  Exception {
    try {
      PreparedStatement ps  = conn.prepareStatement(ISN_CUSTLOGIN);
      ps.setLong(1,clb.getCustNo());      //  
      ps.setString(2,clb.getLUserName()); //  OC[U[
      ps.setString(3,clb.getLPassword()); //  pX[h
      ps.executeUpdate();
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
  }

  //  ̒ǉ
  public  CustLoginBean regMemberInfo(Connection  conn,MemberBean mb)
  throws  Exception {
    CustLoginBean clb = null; //  OC@[U[ApX[hBean
    try {
      //  Vԍ̎擾
      mb.setMemberCd(getMemberCd(conn));
      //  ̒ǉ
      insCustomer(conn,mb);
      //  OC[U[ApX[hBean̍쐬
      clb = makeCustLoginBean(mb);
      //  OC@[U[ApX[ho^
      insCustLogin(conn,clb);
      // gUNṼR~bg
      conn.commit();
    }
    catch(Exception e)  {
      conn.rollback();  //  gUNṼ[obN
      throw e;
    }
    return  clb;
  }


  //  Cӂ̉擾
  private final String GET_CUSTOMER = "SELECT * FROM CUSTOMER WHERE (CUSTNO = ?)";
  public  MemberBean getCustomer(Connection conn,long custno) throws  Exception {
    MemberBean mb  = null;
    try {
      PreparedStatement ps  = conn.prepareStatement(GET_CUSTOMER);
      ps.setLong(1,custno);   //  ԍ
      ResultSet rs  = ps.executeQuery();
      while (rs.next()) {
        mb = new MemberBean();
        mb.setMemberCd(rs.getLong("CUSTNO"));
        mb.setFirstName(rs.getString("FNAME"));
        mb.setLastName(rs.getString("LNAME"));
        mb.setAdder1(rs.getString("ADDER1"));
        mb.setAdder2(rs.getString("ADDER2"));
        mb.setZip(rs.getString("ZIP"));
        mb.setPhone(rs.getString("PHONE"));
        mb.setFax(rs.getString("FAX"));
        mb.setEMail(rs.getString("E_MAIL"));
        mb.setSDate(rs.getDate("SETDATE"));
      }
      rs.close();
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
    return  mb;
  }

  //  މobNAbve[uɒǉ SQL
  private final String  INS_CUSTOMER_BK  = "INSERT INTO CUSTOMER_BK (CUSTNO,FNAME,LNAME,ADDER1,ADDER2,ZIP,PHONE,FAX,E_MAIL,SETDATE) VALUES (?,?,?,?,?,?,?,?,?,?)";
  //  މobNAbve[uɒǉ
  private void  insCustomerBk(Connection conn,MemberBean mb) throws  Exception {
    try {
      PreparedStatement ps  = conn.prepareStatement(INS_CUSTOMER_BK);
      ps.setLong(1,mb.getMemberCd());
      ps.setString(2,mb.getFirstName());
      ps.setString(3,mb.getLastName());
      ps.setString(4,mb.getAdder1());
      ps.setString(5,mb.getAdder2());
      ps.setString(6,mb.getZip());
      ps.setString(7,mb.getPhone());
      ps.setString(8,mb.getFax());
      ps.setString(9,mb.getEMail());
      ps.setDate(10,new java.sql.Date(mb.getSDate().getTime()));
      ps.executeUpdate();
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
  }

   //  ̍폜 SQL
  private final String  DEL_CUSTOMER  = "DELETE FROM CUSTOMER WHERE (CUSTNO = ?)";
  //  ̍폜
  private void  delCustomer(Connection conn,long custno)  throws  Exception {
    try {
      PreparedStatement ps  = conn.prepareStatement(DEL_CUSTOMER);
      ps.setLong(1,custno);
      ps.executeUpdate();
      ps.close();
    }
    catch(SQLException  e)  {
      throw e;
    }
  }

  //  މ
  public  void  delCustInfo(Connection conn,long custno)  throws  Exception {
    try {
      //  މ̎擾
      MemberBean mb  = getCustomer(conn,custno);
      //  މobNAbve[uɒǉ
      insCustomerBk(conn,mb);
      //  ̍폜
      delCustomer(conn,custno);
      //  gUNṼR~bg
      conn.commit();
    }
    catch(Exception e)  {
      //  gUNṼ[obN
      conn.rollback();
      throw e;
    }
  }
}